'  This program sets up the FAIRMODEL workfile, FM.WF1.  It uses FMDATA_E.txt and FMAGE_E.txt, these must be in the root directory. You must select the directory, the end date of the actual data and the end date of the longest forecast horizon. 

'Choose your default directory that 

CD C:\FAIRMODEL\feb2017
' Last year of data
%DEND = "2016q4"
' Forcast horizon
%END = "2022Q4"
' number of records per variable = nobs +1

%field = "261"
'
'
' CREATE WORKFILE
'
wfcreate(wf=FME164) q 1952Q1 %END
'
' End of User Input

' IMPORT DATA
'
import(type=txt) FMDATA_E.TXT ftype=ascii rectype=streamed recfields=%field skip=1 fieldtype=delimited delim=space byrow colhead=1 eoltype=pad badfield=NA @freq Q 1952Q1 @smpl 1952q1 %DEND
import(type=txt, mode=o) FMAGE_E.TXT ftype=ascii rectype=streamed recfields=285 skip=0 fieldtype=delimited delim=space byrow colhead=1 eoltype=pad badfield=NA @freq Q 1952Q1 @smpl @all
'
' RENAME VARIABLES WITH EVIEWS RESERVED NAMES
'
RENAME COS01 COSS
RENAME AR01 ARR
'DELETE COS01
'DELETE AR01
'
' CREATE EXOGENOUS VARIABLES OVER FORECAST HORIZON
'
SMPL %DEND+1 %END
BO = BO(-1)
CCGQ =  CCGQ(-1)*1.002490679
CCHQ = CCHQ(-1)*1.002490679
CCSQ = CCSQ(-1)*1.002490679
CDA=CDA(-1)
COG = COG(-1)*1.002490679
COSS = COSS(-1)*1.004962932
CTB = CTB(-1)
CTF1 = CTF1(-1)
CTGB = CTGB(-1)
CTGMB = CTGMB(-1)
CTH = CTH(-1)
CTNN = CTNN(-1)
CTR = CTR(-1)
CTS = CTS(-1)
D1G = D1G(-1)
D1S = D1S(-1)
D2S = D2S(-1)
D2G = D2G(-1)
D3S = D3S(-1)
D3G = D3G(-1)
D4G = D4G(-1)
D5G = D5G(-1)
D6G=D6G(-1)
D593 = 0
D594 = 0
D601 = 0
D691 = 0
D692 = 0
D714 = 0
D721 = 0
D794823 = 0
DBQ = DBQ(-1)*1.007417072
DELD =DELD(-1)
DELH= DELH(-1)
DELK=DELK(-1)
DG=DG(-1)
DISB=DISB(-1)
DISF=DISF(-1)
DISG=DISG(-1)
DISH=DISH(-1)
DISR =DISR(-1)
DISS = DISS(-1)
DRQ = DRQ(-1)
DS=DS(-1)
EX = EX(-1)*1.019426547
FA=FA(-1)
GSBQ = GSBQ(-1)*1.007417072
GSCA = GSCA(-1)
GSMA = GSMA(-1)
GSNNQ = GSNNQ(-1)
HFS = HFS(-1)
HG=HG(-1)
HM = HM(-1)
HS = HS(-1)
IGZQ  = IGZQ(-1)*1.002490679
IHB=IHB(-1)
IHF  = IHF(-1)*1.007417072
IHHA = IHHA(-1)
IKB  =IKB(-1)*1.007417072
IKG  =IKG(-1)*1.002490679
IKH  =IKH(-1)*1.007417072
INS = INS(-1)
INTF=INTF(-1)
INTS  = INTS(-1)*1.002490679
INTZQ = INTZQ(-1)
ISZQ  = ISZQ(-1)*1.002490679
IVA = IVA(-1)
JG  = JG(-1)*1.002490679
JJP = JJP(-1)
JM=JM(-1)
JS  =JS(-1)*1.002490679
LAM   =LAM(-1)*1.004223172
MDIF =0
MGQ =0
MHQ  = MHQ(-1)*1.007417072
MRQ  = MRQ(-1)*1.007417072
MSQ  = MSQ(-1)*1.007417072
MUH=MUH(-1)
NNF=NNF(-1)
NNG = NNG(-1)
NNH=NNH(-1)
NNR=NNR(-1)
NNS=NNS(-1)
PIM  =PIM(-1)
POP1 = POP1(-1)
POP2 = POP2(-1)
POP3  =POP3(-1)*1.004962932
PSI1 = PSI1(-1)
PSI2 = PSI2(-1)
PSI3 = PSI3(-1)
PSI4 = PSI4(-1)
PSI5 = PSI5(-1)
PSI6 = PSI6(-1)
PSI7 = PSI7(-1)
PSI8 = PSI8(-1)
PSI9 = PSI9(-1)
PSI10 = PSI10(-1)
PSI11 = PSI11(-1)
PSI12 = PSI12(-1)
PSI13 = PSI13(-1)
PSI14 = PSI14(-1)*1.007417072
PSI15 = PSI15(-1)
QQ = QQ(-1)
RNTQ  = RNTQ(-1)*1.012272234
SIFS  = SIFS(-1)*1.009853407
SIGG  = SIGG(-1)*1.009853407
SIHS  =SIHS(-1)*1.009853407
SISS  = SISS(-1)*1.009853407
STAT = STAT(-1)
STATP=STATP(-1)
SUBG=SUBG(-1)
SUBS=SUBS(-1)
T = T(-1) + 1
TAUG = TAUG(-1)
TAUS = TAUS(-1)
TFR  =TFR(-1)*1.012272234
TBGQ  =TBGQ(-1)*1.007417072
TBS  =TBS(-1)*1.007417072
THETA1=THETA1(-1)
THETA2=THETA2(-1)
THETA3=THETA3(-1)
THETA4=THETA4(-1)
TRFG=TRFG(-1)
TRFH  =TRFH(-1)*1.009853407
TRFR=TRFR(-1)
TRFS   =TRFS(-1)*1.012272234
TRGHQ  = TRGHQ(-1)*1.009853407
TRGR=TRGR(-1)
TRGSQ  = TRGSQ(-1)*1.009853407
TRHR=TRHR(-1)
TRRS=TRRS(-1)
TRSHQ  = TRSHQ(-1)*1.019426547
USAFF=USAFF(-1)
USOTHER=USOTHER(-1)
SMPL 2016Q2 2016Q2
BR = 1900
SMPL 2016Q3 2020Q4
BR = BR(-1) - 100
SMPL 2021Q1 %END
BR = 100
SMPL 1952Q1 1968Q4
SERIES CNST2 = 0
SMPL 1969Q1 1988Q3
CNST2 = CNST2(-1) + .0125
SMPL 1988Q4 %END
CNST2 = 1
SMPL @ALL
SERIES COGS = COG+COSS
SMPL 1952Q1 %END
SERIES TB = CNST2*T
SERIES RSTEMP = RS
SMPL 2022Q4 %END
AG1 = @ELEM(AG1,"2022Q4")
AG2 = @ELEM(AG2,"2022Q4")
AG3 = @ELEM(AG3,"2022Q4")
'
' DETETE EXTRANEOUS VARIABLES
'
DELETE ZERO3
DELETE ZERO4
DELETE TESTZERO
DELETE NONE9
DELETE NONE19
DELETE NONE20
DELETE NONE21
DELETE NONE22
DELETE EXPGZGDP
DELETE PCGDPD4
DELETE PCGDPR4
DELETE RECGZGDP
DELETE SGPZGDP
DELETE SRZGDP
DELETE AGZGDP
DELETE ASZGDP
DELETE GNPD01
DELETE INTGZGDP
DELETE USROW01
' 
' CREATE EQUATIONS
'
SMPL 1954:1 %DEND
EQUATION EQ01_CS.TSLS(NOEXINST) log(CS/POP) CNST2 C AG1 AG2 AG3 log(CS(-1)/POP(-1)) LOG(YD/(POP*PH)) RS*(1-D1GM-D1SM) LOG(AA(-1)/POP(-1)) @ CNST2 C AG1 AG2 AG3 log(CS(-1)/POP(-1)) LOG(AA(-1)/POP(-1)) T LOG(YD(-1)/(POP(-1)*PH(-1))) RS(-1)*(1-D1GM(-1)-D1SM(-1)) LOG(1-D1GM(-1)-D1SM(-1)-D4G(-1))    LOG(IM(-1)/POP(-1)) LOG((JG*HG+JM*HM+JS*HS)/POP )  LOG(PIM(-1)/PF(-1)) LOG(YNL(-1)/(POP(-1)*PH(-1))) 100*((PD(-1)/PD(-2))^4-1)    LOG(COGS/POP) LOG((TRGH+TRSH)/(POP*PH(-1))) RS(-2) RB(-1) LOG(Y(-1)/POP(-1)) LOG(V(-1)/X(-1))  UR(-1) LOG(YD/(POP*PH)) 
'
EQUATION EQ02_CN.TSLS(NOEXINST) LOG(CN/POP) CNST2 C AG1 AG2 AG3 LOG(CN(-1)/POP(-1)) DLOG(CN(-1)/POP(-1))    LOG(AA(-1)/POP(-1)) LOG(YD/(POP*PH)) RM*(1-D1GM-D1SM) @ CNST2 C AG1 AG2 AG3 LOG(CN(-1)/POP(-1)) DLOG(CN(-1)/POP(-1))   LOG(AA(-1)/POP(-1)) LOG(YD(-1)/(POP(-1)*PH(-1))) RM(-1)*(1-D1GM(-1)-D1SM(-1)) LOG(COGS/POP) LOG(EX(-1)/POP(-1)) LOG(1-D1GM(-1)-D1SM(-1)-D4G(-1))    LOG(IM(-1)/POP(-1)) LOG((TRGH+TRSH)/(POP*PH(-1))) LOG((JG*HG+JM*HM+JS*HS)/POP )  LOG(YNL(-1)/(POP(-1)*PH(-1))) LOG(PIM(-1)/PF(-1)) 100*((PD(-1)/PD(-2))^4-1)    UR(-1) LOG(V(-1)/X(-1))  RS(-1) RS(-2) T
'
EQUATION EQ03_CD.TSLS(NOEXINST) D(CD/POP) CNST2 C AG1 AG2 AG3 (DELD*KD(-1)-CD(-1))/POP(-1)  KD(-1)/POP(-1)  YD/(POP*PH) RM*(1-D1GM-D1SM)*CDA    AA(-1)/POP(-1) @ CNST2 C AG1 AG2 AG3 KD(-1)/POP(-1)  AA(-1)/POP(-1) YD(-1)/(POP(-1)*PH(-1))  RM(-1)*(1-D1GM(-1)-D1SM(-1))*CDA(-1)  LOG(COGS/POP) LOG(EX(-1)/POP(-1)) LOG(1-D1GM(-1)-D1SM(-1)-D4G(-1))    LOG(Y(-1)/POP(-1)) LOG(V(-1)/X(-1))  LOG(IM(-1)/POP(-1)) LOG((TRGH+TRSH)/(POP*PH(-1))) LOG(YNL(-1)/(POP(-1)*PH(-1))) LOG(PIM(-1)/PF(-1)) (DELD*KD(-1)-CD(-1))/POP(-1)  T
'
EQUATION EQ04_IHH.TSLS(NOEXINST) D(IHH/POP) CNST2 C (DELH*KH(-1)-IHH(-1))/POP(-1)  KH(-1)/POP(-1)   YD/(POP*PH) RM(-1)*(1-D1GM(-1)-D1SM(-1))*IHHA  AA2(-1)/POP(-1)  AR(1) AR(2) @ CNST2 CNST2(-1) CNST2(-2) C KH(-1)/POP(-1) RM(-1)*(1-D1GM(-1)-D1SM(-1))*IHHA YD(-1)/(POP(-1)*PH(-1)) KH(-2)/POP(-2) KH(-3)/POP(-3) RM(-2)*(1-D1GM(-2)-D1SM(-2))*IHHA(-1) RM(-3)*(1-D1GM(-3)-D1SM(-3))*IHHA(-2) YD(-2)/(POP(-2)*PH(-2))  LOG(COGS/POP) LOG((JG*HG+JM*HM+JS*HS)/POP)  LOG((TRGH+TRSH)/(POP*PH(-1)))  LOG(EX(-1)/POP(-1)) LOG(1-D1GM(-1)-D1SM(-1)-D4G(-1)) LOG(YNL(-1)/(POP(-1)*PH(-1))) 100*((PD(-1)/PD(-2))^4-1) LOG(IM(-1)/POP(-1)) (DELH*KH(-1)-IHH(-1))/POP(-1) (DELH(-1)*KH(-2)-IHH(-2))/POP(-2) (DELH(-2)*KH(-3)-IHH(-3))/POP(-3) D(IHH(-1)/POP(-1)) D(IHH(-2)/POP(-2)) AA2(-1)/POP(-1) AA2(-2)/POP(-2) AA2(-3)/POP(-3)
'
EQUATION EQ05_L1.TSLS(NOEXINST) LOG(L1/POP1)  C LOG(L1(-1)/POP1(-1)) LOG(AA(-1)/POP(-1)) UR @ C LOG(L1(-1)/POP1(-1)) LOG(AA(-1)/POP(-1)) UR(-1) LOG(COGS/POP) LOG((JG*HG+JM*HM+JS*HS)/POP )  LOG(PIM(-1)/PF(-1)) LOG(YNL(-1)/(POP(-1)*PH(-1))) LOG(Y(-1)/POP(-1)) LOG(V(-1)/X(-1))  100*((PD(-1)/PD(-2))^4-1)    LOG(1-D1GM(-1)-D1SM(-1)-D4G(-1))    LOG(IM(-1)/POP(-1)) T
EQUATION EQ06_L2.TSLS(NOEXINST) LOG(L2/POP2) C LOG(L2(-1)/POP2(-1)) LOG(WA/PH) LOG(AA(-1)/POP(-1)) @ C LOG(AA(-1)/POP(-1)) LOG(WA(-1)/PH(-1)) T
'
EQUATION EQ07_L3.TSLS(NOEXINST) LOG(L3/POP3) C LOG(L3(-1)/POP3(-1)) LOG(WA/PH) LOG(AA(-1)/POP(-1)) UR @ C LOG(L3(-1)/POP3(-1)) LOG(AA(-1)/POP(-1)) LOG(WA(-1)/PH(-1)) UR(-1) LOG((JG*HG+JM*HM+JS*HS)/POP )  LOG((TRGH+TRSH)/(POP*PH(-1))) LOG(EX(-1)/POP(-1)) LOG(IM(-1)/POP(-1)) LOG(1-D1GM(-1)-D1SM(-1)-D4G(-1))    LOG(PIM(-1)/PF(-1)) 100*((PD(-1)/PD(-2))^4-1)    LOG(Y(-1)/POP(-1)) T
'
EQUATION EQ08_LM.TSLS(NOEXINST) LOG(LM/POP) C LOG(LM(-1)/POP(-1)) LOG(WA/PH) UR  @  C LOG(LM(-1)/POP(-1)) LOG(WA(-1)/PH(-1))   UR(-1) LOG((JG*HG+JM*HM+JS*HS)/POP )  LOG(PIM(-1)/PF(-1)) 100*((PD(-1)/PD(-2))^4-1)    RS(-1) RS(-2) RB(-1) LOG(COGS/POP) LOG((TRGH+TRSH)/(POP*PH(-1))) LOG(1-D1GM(-1)-D1SM(-1)-D4G(-1))    LOG(YNL(-1)/(POP(-1)*PH(-1))) LOG(AA(-1)/POP(-1)) LOG(EX(-1)/POP(-1)) LOG(IM(-1)/POP(-1)) LOG(Y(-1)/POP(-1)) LOG(V(-1)/X(-1))  T
'
EQUATION EQ10_PF.TSLS(NOEXINST) LOG(PF) LOG(PF(-1)) LOG(WF*(1+D5G))-LOG(LAM) CNST2 T*CNST2  C T LOG(PIM) UR @ LOG(PF(-1)) LOG(WF(-1)*(1+D5G(-1)))-LOG(LAM(-1))  CNST2 T*CNST2 C T LOG(PIM(-1)/PF(-1)) UR(-1) LOG(COGS/POP) LOG(EX(-1)/POP(-1)) LOG(IM(-1)/POP(-1)) LOG(1-D1GM(-1)-D1SM(-1)-D4G(-1))    LOG(YNL(-1)/(POP(-1)*PH(-1))) LOG((TRGH+TRSH)/(POP*PH(-1))) LOG(AA(-1)/POP(-1)) LOG(Y(-1)/POP(-1))
SCALAR DELTA1  = C(1)/(1-C(2))
'
EQUATION EQ11_Y.TSLS(NOEXINST) LOG(Y) C LOG(Y(-1)) LOG(X) LOG(V(-1)) D593 D594 D601 AR(1) AR(2) AR(3) @ C LOG(Y(-1)) LOG(V(-1)) LOG(Y(-2)) LOG(Y(-3)) LOG(Y(-4)) LOG(V(-2)) LOG(V(-3)) LOG(V(-4)) D593 D594 D601 D601(-1) D601(-2) D601(-3) T LOG(COGS/POP) LOG((TRGH+TRSH)/(POP*PH(-1))) LOG(EX(-1)/POP(-1)) LOG(IM(-1)/POP(-1)) LOG(1-D1GM(-1)-D1SM(-1)-D4G(-1))    LOG(PIM(-1)/PF(-1)) LOG(YNL(-1)/(POP(-1)*PH(-1))) UR(-1) RS(-1) RB(-1) 100*((PD(-1)/PD(-2))^4-1)   
'
EQUATION EQ12_KK.TSLS(NOEXINST) DLOG(KK) CNST2 C LOG(KK(-1)/KKMIN(-1)) DLOG(KK(-1)) DLOG(Y) DLOG(Y(-1))  DLOG(Y(-2)) DLOG(Y(-3)) DLOG(Y(-4))  RB(-2)*(1-D2G(-2)-D2S(-2))-100*(PD(-2)/PD(-6)-1)   (CG(-2)+CG(-3)+CG(-4))/(PX(-2)*YS(-2)+PX(-3)*YS(-3)+PX(-4)*YS(-4)) @ CNST2 C LOG(KK(-1)) LOG(KK(-2)) LOG(Y(-1)) LOG(Y(-2)) LOG(Y(-3)) LOG(Y(-4)) LOG(Y(-5)) LOG((JG*HG+JM*HM+JS*HS)/POP )  LOG((TRGH+TRSH)/(POP*PH(-1))) LOG(1-D1GM(-1)-D1SM(-1)-D4G(-1))    LOG(YNL(-1)/(POP(-1)*PH(-1))) UR(-1) LOG(EX(-1)/POP(-1)) LOG(AA(-1)/POP(-1)) RB(-2)*(1-D2G(-2)-D2S(-2))-100*(PD(-2)/PD(-6)-1) (CG(-2)+CG(-3)+CG(-4))/(PX(-2)*YS(-2)+PX(-3)*YS(-3)+PX(-4)*YS(-4)) LOG(KK(-1)/KKMIN(-1)) T
'
EQUATION EQ13_JF.TSLS(NOEXINST) DLOG(JF) C LOG(JF(-1)/(JHMIN(-1)/HFS(-1))) DLOG(JF(-1)) DLOG(Y) D593 @ C LOG(JF(-1)/(JHMIN(-1)/HFS(-1)))  DLOG(JF(-1)) DLOG(Y(-1)) D593  LOG(COGS/POP) LOG((JG*HG+JM*HM+JS*HS)/POP )  LOG(EX(-1)/POP(-1)) LOG(IM(-1)/POP(-1)) LOG(1-D1GM(-1)-D1SM(-1)-D4G(-1))    100*((PD(-1)/PD(-2))^4-1)    UR(-1) LOG(Y(-1)/POP(-1)) LOG(V(-1)/X(-1))  RS(-1) RS(-2) RB(-1) LOG((TRGH+TRSH)/(POP*PH(-1))) LOG(YNL(-1)/(POP(-1)*PH(-1))) LOG(AA(-1)/POP(-1)) LOG(PIM(-1)/PF(-1)) T
'
EQUATION EQ14_HF.TSLS(NOEXINST) DLOG(HF) C LOG(HF(-1)/HFS(-1)) LOG(JF(-1)/(JHMIN(-1)/HFS(-1))) DLOG(Y) T @ C LOG(HF(-1)/HFS(-1)) LOG(JF(-1)/(JHMIN(-1)/HFS(-1)))  DLOG(Y(-1)) T LOG((JG*HG+JM*HM+JS*HS)/POP )  100*((PD(-1)/PD(-2))^4-1)    UR(-1) RS(-1) RS(-2) LOG(PIM(-1)/PF(-1))  
'
SMPL 1956:1 %DEND
EQUATION EQ15_HO.LS(arma=cls, optmethod=legacy) LOG(HO) C HFF HFF(-1) AR(1) 
'
SMPL 1954:1 %DEND
EQUATION EQ16_WF.TSLS(NOEXINST) LOG(WF/LAM) = C(1)* LOG(WF(-1)/LAM(-1)) +C(2)*LOG(PF)+(DELTA1*(1-C(2))-C(1))*LOG(PF(-1)) +C(3)+ C(4)*T @ LOG(WF(-1)/LAM(-1))-LOG(PF(-1)) LOG(PF(-1))-DELTA1*LOG(PF(-2))  C T LOG(COGS/POP) LOG((JG*HG+JM*HM+JS*HS)/POP )  LOG((TRGH+TRSH)/(POP*PH(-1))) LOG(EX(-1)/POP(-1)) LOG(1-D1GM(-1)-D1SM(-1)-D4G(-1))    LOG(YNL(-1)/(POP(-1)*PH(-1))) UR(-1) LOG(Y(-1)/POP(-1)) LOG(V(-1)/X(-1))  LOG(PIM(-1)/PF(-1)) RS(-1) RS(-2) RB(-1) 
'
EQUATION EQ17_MF.TSLS(NOEXINST) LOG(MF/PF) C LOG(MF(-1)/PF) LOG(X-FA)  RS*(1-D2G-D2S) @ C LOG(MF(-1)/PF(-1)) LOG(X(-1)-FA(-1)) RS(-1)*(1-D2G(-1)-D2S(-1)) T LOG(COGS/POP) LOG((JG*HG+JM*HM+JS*HS)/POP )  LOG(EX(-1)/POP(-1)) LOG(IM(-1)/POP(-1)) LOG(1-D1GM(-1)-D1SM(-1)-D4G(-1))    LOG(PIM(-1)/PF(-1)) LOG(YNL(-1)/(POP(-1)*PH(-1)))100*((PD(-1)/PD(-2))^4-1)    UR(-1) LOG(Y(-1)/POP(-1)) LOG(V(-1)/X(-1))  RS(-2) RB(-1)
'
EQUATION EQ18_DF.TSLS(NOEXINST) DLOG(DF) LOG((PIEF-TFG-TFS-TFR)/DF(-1)) @ LOG((PIEF(-1)-TFG(-1)-TFS(-1)-TFR(-1))/DF(-2)) C LOG((JG*HG+JM*HM+JS*HS)/POP )  100*((PD(-1)/PD(-2))^4-1)    UR(-1) RS(-1) RS(-2) LOG(PIM(-1)/PF(-1)) T
'
EQUATION EQ23_RB.TSLS(NOEXINST) RB = C(1) + C(2)*RB(-1)+ C(3)*RS +C(4)*RS(-1) +(1-C(2)-C(3)-C(4))*RS(-2) + [AR(1)=C(5)] @ C RB(-1) RB(-2) RS(-1) RS(-2) RS(-3) LOG(COGS/POP) LOG((JG*HG+JM*HM+JS*HS)/POP )  LOG((TRGH+TRSH)/(POP*PH(-1))) LOG(EX(-1)/POP(-1)) LOG(IM(-1)/POP(-1)) LOG(1-D1GM(-1)-D1SM(-1)-D4G(-1))    LOG(PIM(-1)/PF(-1)) LOG(YNL(-1)/(POP(-1)*PH(-1)))100*((PD(-1)/PD(-2))^4-1)    UR(-1) LOG(Y(-1)/POP(-1)) LOG(V(-1)/X(-1))  LOG(AA(-1)/POP(-1)) T
'
EQUATION EQ24_RM.TSLS(NOEXINST) RM = C(1) +C(2)*RM(-1)+C(3)*RS +C(4)*RS(-1)+(1-C(2)-C(3)-C(4))*RS(-2)  @ C RM(-1) RS(-1) RS(-2)  LOG(COGS/POP) LOG((JG*HG+JM*HM+JS*HS)/POP )  LOG((TRGH+TRSH)/(POP*PH(-1))) LOG(EX(-1)/POP(-1)) LOG(IM(-1)/POP(-1)) LOG(1-D1GM(-1)-D1SM(-1)-D4G(-1))    LOG(PIM(-1)/PF(-1)) LOG(YNL(-1)/(POP(-1)*PH(-1))) 100*((PD(-1)/PD(-2))^4-1)    UR(-1) LOG(Y(-1)/POP(-1)) LOG(V(-1)/X(-1))  LOG(AA(-1)/POP(-1)) T
'
EQUATION EQ25_CG.TSLS(NOEXINST) CG/(PX(-1)*YS(-1)) C D(RB) (PIEF-TFG-TFS-TFR-(PIEF(-1)-TFG(-1)-TFS(-1)-TFR(-1)))/(PX(-1)*YS(-1))  @ C D(RB(-1)) (PIEF(-1)-TFG(-1)-TFS(-1)-TFR(-1)-(PIEF(-2)-TFG(-2)-TFS(-2)-TFR(-2)))/(PX(-2)*YS(-2))  T LOG(COGS/POP) LOG((JG*HG+JM*HM+JS*HS)/POP )  LOG((TRGH+TRSH)/(POP*PH(-1))) LOG(EX(-1)/POP(-1)) LOG(IM(-1)/POP(-1)) LOG(1-D1GM(-1)-D1SM(-1)-D4G(-1))    LOG(PIM(-1)/PF(-1)) LOG(YNL(-1)/(POP(-1)*PH(-1)))100*((PD(-1)/PD(-2))^4-1)    UR(-1) LOG(Y(-1)/POP(-1)) LOG(V(-1)/X(-1))  RS(-1) RS(-2) RB(-1) LOG(AA(-1)/POP(-1))
'
EQUATION EQ26_CUR.TSLS(NOEXINST) LOG(CUR/(POP*PF))  C LOG(CUR(-1)/(POP(-1)*PF))  LOG((X-FA)/POP)  RS*(1-D1GM-D1SM) AR(1) @ C LOG(CUR(-1)/(POP(-1)*PF(-1))) LOG((X(-1)-FA(-1))/POP(-1)) RS(-1)*(1-D1GM(-1)-D1SM(-1)) LOG(CUR(-2)/(POP(-2)*PF(-1)))   T LOG(COGS/POP) LOG((JG*HG+JM*HM+JS*HS)/POP )  LOG((TRGH+TRSH)/(POP*PH(-1))) LOG(EX(-1)/POP(-1)) LOG(IM(-1)/POP(-1)) LOG(1-D1GM(-1)-D1SM(-1)-D4G(-1))    LOG(PIM(-1)/PF(-1)) LOG(YNL(-1)/(POP(-1)*PH(-1)))  UR(-1) LOG(Y(-1)/POP(-1)) LOG(V(-1)/X(-1))  RS(-2) RB(-1) LOG(AA(-1)/POP(-1)) 100*((PD(-1)/PD(-2))^4-1)   
'
EQUATION EQ27_IM.TSLS(NOEXINST) LOG(IM/POP) CNST2 C LOG(IM(-1)/POP(-1)) LOG((CS+CN+CD+IHH+IKF+IKH+IKB+IHF+IHB)/POP)  LOG(PF/PIM)  D691 D692 D714 D721 @ CNST2 C LOG(IM(-1)/POP(-1)) LOG((CS(-1)+CN(-1)+CD(-1)+IHH(-1)+IKF(-1)+IKH(-1)+IKB(-1)+IHF(-1)+IHB(-1))/POP(-1)) LOG(PF(-1)/PIM(-1)) D691 D692 D714 D721 LOG(COGS/POP) LOG((JG*HG+JM*HM+JS*HS)/POP )  LOG((TRGH+TRSH)/(POP*PH(-1))) LOG(EX(-1)/POP(-1)) LOG(1-D1GM(-1)-D1SM(-1)-D4G(-1))    LOG(YNL(-1)/(POP(-1)*PH(-1))) 100*((PD(-1)/PD(-2))^4-1)    UR(-1) LOG(Y(-1)/POP(-1)) LOG(V(-1)/X(-1))  RS(-1) RB(-1) LOG(AA(-1)/POP(-1)) T
'
EQUATION EQ28_UB.TSLS(NOEXINST) LOG(UB) C LOG(UB(-1)) LOG(U) LOG(WF) AR(1) @ C LOG(UB(-1)) LOG(U(-1)) LOG(WF(-1)) LOG(UB(-2)) LOG(COGS/POP) LOG((JG*HG+JM*HM+JS*HS)/POP )  LOG((TRGH+TRSH)/(POP*PH(-1))) LOG(IM(-1)/POP(-1)) LOG(1-D1GM(-1)-D1SM(-1)-D4G(-1))    LOG(PIM(-1)/PF(-1)) LOG(YNL(-1)/(POP(-1)*PH(-1))) 100*((PD(-1)/PD(-2))^4-1)    RS(-1) RS(-2) T
'
EQUATION EQ29_INTG.LS(arma=cls, optmethod=legacy) -(INTG/AG) C -(INTG(-1)/AG(-1)) (.4*(RS/400)+.75*.6*(1/8)*(1/400)*(RB+RB(-1)+RB(-2)+RB(-3)+RB(-4)+RB(-5)+RB(-6)+RB(-7)))  AR(1)
'
SMPL 1954Q1 2008Q3
EQUATION EQ30_RS.TSLS(NOEXINST) RSTEMP C RS(-1) 100*((PD/PD(-1))^4-1)   UR D(UR) 100*((M1(-1)/M1(-2))^4 -1)  D794823*100*((M1(-1)/M1(-2))^4 -1)   D(RS(-1)) D(RS(-2)) @ C RS(-1) 100*((PD(-1)/PD(-2))^4-1)    UR(-1) D(UR(-1)) 100*((M1(-1)/M1(-2))^4-1)  D794823*100*((M1(-1)/M1(-2))^4-1)  D(RS(-1)) D(RS(-2)) T LOG(COGS/POP) LOG((JG*HG+JM*HM+JS*HS)/POP )  LOG((TRGH+TRSH)/(POP*PH(-1))) LOG(EX(-1)/POP(-1)) LOG(IM(-1)/POP(-1)) LOG(1-D1GM(-1)-D1SM(-1)-D4G(-1))    LOG(PIM(-1)/PF(-1)) LOG(YNL(-1)/(POP(-1)*PH(-1))) LOG(Y(-1)/POP(-1)) LOG(V(-1)/X(-1))  LOG(AA(-1)/POP(-1))
'
' CREATE FAIRMODEL_EV
'
model FMA_EV
fma_ev.merge eq01_cs
fma_ev.merge eq02_cn
fma_ev.merge eq03_cd
fma_ev.merge eq04_ihh
fma_ev.merge eq05_l1
fma_ev.merge eq06_l2
fma_ev.merge eq07_l3
fma_ev.merge eq08_lm
fma_ev.merge eq10_pf
fma_ev.merge eq11_y
fma_ev.merge eq12_kk
fma_ev.merge eq13_jf
fma_ev.merge eq14_hf
fma_ev.merge eq15_ho
fma_ev.merge eq16_wf
fma_ev.merge eq17_mf
fma_ev.merge eq18_df
fma_ev.merge eq23_rb
fma_ev.merge eq24_rm
fma_ev.merge eq25_cg
fma_ev.merge eq26_cur
fma_ev.merge eq27_im
fma_ev.merge eq28_ub
fma_ev.merge eq29_intg
fma_ev.merge eq30_rs
FMA_EV.APPEND @IDENTITY RS  = (ABS(RSTEMP)  + RSTEMP)  / 2

FMA_EV.APPEND @IDENTITY PX  = (PF  * (X  - FA)  + PFA  * FA)  / X

FMA_EV.APPEND @IDENTITY PEX  = PSI1  * PX

FMA_EV.APPEND @IDENTITY PD  = (PX  * X  - PEX  * EX  + PIM  * IM)  / (X  - EX  + IM)

FMA_EV.APPEND @IDENTITY PH  = (PCS  * CS  + PCN  * CN  + PCD  * CD  + PIH  * IHH  + IBTG  + IBTS)  / (CS  + CN  + CD  + IHH)

FMA_EV.APPEND @IDENTITY PCS  = PSI2  * (1  + D3G  + D3S)  * PD

FMA_EV.APPEND @IDENTITY PCN  = PSI3  * (1  + D3G  + D3S)  * PD

FMA_EV.APPEND @IDENTITY PCD  = PSI4  * (1  + D3G  + D3S)  * PD

FMA_EV.APPEND @IDENTITY PIH  = PSI5  * PD

FMA_EV.APPEND @IDENTITY PIK  = PSI6  * PD

FMA_EV.APPEND @IDENTITY PG  = PSI7  * PD

FMA_EV.APPEND @IDENTITY PS  = PSI8  * PD

FMA_EV.APPEND @IDENTITY PIV  = PSI9  * PD

FMA_EV.APPEND @IDENTITY WH  = 100  * ((WF  * JF  * (HN  + 1.5  * HO)  + WG  * JG  * HG  + WM  * JM  * HM  + WS  * JS  * HS)  / (JF  * (HN  + 1.5  * HO)  + JG  * HG  + JM  * HM  + JS  * HS))

FMA_EV.APPEND @IDENTITY WG  = PSI10  * WF

FMA_EV.APPEND @IDENTITY WM  = PSI11  * WF

FMA_EV.APPEND @IDENTITY WS  = PSI12  * WF

FMA_EV.APPEND @IDENTITY THG  = (D1G  + ((TAUG  * YT)  / (PH  * POP)))  * YT

FMA_EV.APPEND @IDENTITY THS  = (D1S  + ((TAUS  * YT)  / (PH  * POP)))  * YT

FMA_EV.APPEND @IDENTITY TFG  = D2G  * (PIEF  - TFS)

FMA_EV.APPEND @IDENTITY TFS  = D2S  * PIEF

FMA_EV.APPEND @IDENTITY IBTG  = (D3G  / (1  + D3G))  * (PCS  * CS  + PCN  * CN  + PCD  * CD  - IBTS)

FMA_EV.APPEND @IDENTITY IBTS  = (D3S  / (1  + D3S))  * (PCS  * CS  + PCN  * CN  + PCD  * CD  - IBTG)

FMA_EV.APPEND @IDENTITY SIHG  = D4G  * (WF  * JF  * (HN  + 1.5  * HO))

FMA_EV.APPEND @IDENTITY SIFG  = D5G  * (WF  * JF  * (HN  + 1.5  * HO))

FMA_EV.APPEND @IDENTITY PKH  = PSI14  * PD

FMA_EV.APPEND @IDENTITY KD  = (1  - DELD)  * KD(-1)  + CD

FMA_EV.APPEND @IDENTITY INTGR  = PSI15  * INTG

FMA_EV.APPEND @IDENTITY USROW  =  - INTGR  + DR  + PIEFRET  + USOTHER

FMA_EV.APPEND @IDENTITY KH  = (1  - DELH)  * KH(-1)  + IHH

FMA_EV.APPEND @IDENTITY X  = CS  + CN  + CD  + IHH  + IKF  + EX  - IM  + COG  + COSS  + IKH  + IKB  + IKG  + IHF  + IHB

FMA_EV.APPEND @IDENTITY XX  = PCS  * CS  + PCN  * CN  + PCD  * CD  + PIH  * (IHB  + IHF  + IHH)  + PIK  * (IKH  + IKG  + IKB  + IKF)  + PEX  * EX  - PIM  * IM  + PG  * COG  + PS  * COSS  - IBTG  - IBTS

FMA_EV.APPEND @IDENTITY HN  = HF  - HO

FMA_EV.APPEND @IDENTITY V  = V(-1)  + Y  - X

FMA_EV.APPEND @IDENTITY YT  = WF  * JF  * (HN  + 1.5  * HO)  + WG  * JG  * HG  + WM  * JM  * HM  + WS  * JS  * HS  + RNT  + INTZ  + INTF  + INTG  - INTGR  + INTS  + DF  + DB  + DR  + DG  + DS  + TRFH  - TRHR  - SIGG  - SISS

FMA_EV.APPEND @IDENTITY SH  = YT  - SIHG  - SIHS  + USAFF  - THG  - THS  - PCS  * CS  - PCN  * CN  - PCD  * CD  + TRGH  + TRSH  + UB  + INS  + NICD  + CCH  - CTH  - PIH  * IHH  - CDH  - PIK  * IKH  - NNH

FMA_EV.APPEND @IDENTITY AH  = AH(-1)  + SH  - MH  + MH(-1)  + CG  - DISH

FMA_EV.APPEND @IDENTITY CCF1  = D6G  * (PIK  * IKF  + PIK(-1)  * IKF(-1)  + PIK(-2)  * IKF(-2)  + PIK(-3)  * IKF(-3))  / 4.

FMA_EV.APPEND @IDENTITY PIEF  = XX  + PIV  * IVF  + SUBS  + SUBG  + USOTHER  - WF  * JF  * (HN  + 1.5  * HO)  - RNT  - INTZ  - INTF  - TRFH  - NICD  - CCH  + CDH  - TBS  - TRFS  - CCS  - TRFR  - DB  - GSB  - CTGB  - GSMA  - GSCA  - TBG  - TRFG  - CCG  - SIFG  - SIFS  - GSNN  - IVA  - CCF1  - STAT

FMA_EV.APPEND @IDENTITY SF  = XX  + SUBS  + SUBG  + USOTHER  + PIEFRET  - WF  * JF  * (HN  + 1.5  * HO)  - RNT  - INTZ  - INTF  - TRFH  - NICD  - CCH  + CDH  - TBS  - TRFS  - CCS  - TRFR  - DB  - GSB  - CTGB  - GSMA  - GSCA  - TBG  - TRFG  - CCG  - SIFG  - SIFS  - STAT  - DF  - TF1  - PIK  * IKF  - PIH  * IHF  - NNF  - CTF1  - CTNN

FMA_EV.APPEND @IDENTITY AF  = AF(-1)  + SF  - MF  + MF(-1)  - DISF

FMA_EV.APPEND @IDENTITY MB  = MB(-1)  - MH  + MH(-1)  - MF  + MF(-1)  - MR  + MR(-1)  - MG  + MG(-1)  - MS  + MS(-1)  + CUR  - CUR(-1)

FMA_EV.APPEND @IDENTITY SB  = GSB  - CTB  - PIH  * IHB  - PIK  * IKB

FMA_EV.APPEND @IDENTITY AB  = AB(-1)  + SB  - MB  + MB(-1)  - (BR  - BO)  + (BR(-1)  - BO(-1))  - DISB

FMA_EV.APPEND @IDENTITY SR  =  - PEX  * EX  - USROW  + PIM  * IM  + TFR  + TRFR  + TRHR  + TRGR  - USAFF  - CTR  - NNR  - TRRS

FMA_EV.APPEND @IDENTITY ARR  = ARR(-1)  + SR  - MR  + MR(-1)  + Q  - Q(-1)  - DISR

FMA_EV.APPEND @IDENTITY SG  = GSMA  + GSCA  + THG  + IBTG  + TBG  + TFG  + SIHG  + SIFG  - DG  + TRFG  - PG  * COG  - WG  * JG  * HG  - WM  * JM  * HM  - TRGH  - TRGR  - TRGS  - INTG  - SUBG  + CCG  - INS  - USAFF  - CTGMB  - NNG  - PIK  * IKG  + SIGG

FMA_EV.APPEND @IDENTITY AG  = AG(-1)  + SG  - MG  + MG(-1)  + CUR  - CUR(-1)  + (BR  - BO)  - (BR(-1)  - BO(-1))  - Q  + Q(-1)  - DISG

FMA_EV.APPEND @IDENTITY SS  = THS  + IBTS  + TBS  + TFS  + SIHS  + SIFS  - DS  + TRGS  + TRFS  - PS  * COSS  - WS  * JS  * HS  - TRSH  - UB  - INTS  - SUBS  + CCS  - CTS  - NNS  + SISS  + TRRS

FMA_EV.APPEND @IDENTITY AS  = AS(-1)  + SS  - MS  + MS(-1)  - DISS

FMA_EV.APPEND @IDENTITY M1  = M1(-1)  + MH  - MH(-1)  + MF  - MF(-1)  + MR  - MR(-1)  + MS  - MS(-1)  + MDIF

FMA_EV.APPEND @IDENTITY GDP  = XX  + PIV  * (V  - V(-1))  + IBTG  + IBTS  + WG  * JG  * HG  + WM  * JM  * HM  + WS  * JS  * HS

FMA_EV.APPEND @IDENTITY GDPR  = Y  + PSI13  * (JG  * HG  + JM  * HM  + JS  * HS)  + STATP

FMA_EV.APPEND @IDENTITY GDPD  = GDP  / GDPR

FMA_EV.APPEND @IDENTITY E  = JF  + JG  + JM  + JS  - LM

FMA_EV.APPEND @IDENTITY U  = L1  + L2  + L3  - E

FMA_EV.APPEND @IDENTITY UR  = U  / (L1  + L2  + L3  - JM)

FMA_EV.APPEND @IDENTITY AA1  = (AH  + MH)  / PH

FMA_EV.APPEND @IDENTITY AA2  = (KH  * PKH)  / PH

FMA_EV.APPEND @IDENTITY D1GM  = D1G  + (2  * TAUG  * YT)  / (POP  * PH)

FMA_EV.APPEND @IDENTITY D1SM  = D1S  + (2  * TAUS  * YT)  / (POP  * PH)

FMA_EV.APPEND @IDENTITY IKF  = KK  - (1  - DELK)  * KK(-1)

FMA_EV.APPEND @IDENTITY KKMIN  = Y  / MUH

FMA_EV.APPEND @IDENTITY JHMIN  = Y  / LAM

FMA_EV.APPEND @IDENTITY JJ  = (JF  * HF  + JG  * HG  + JM  * HM  + JS  * HS)  / POP

FMA_EV.APPEND @IDENTITY CDH  = THETA2  * PCD  * CD

FMA_EV.APPEND @IDENTITY NICD  = THETA3  * PCD  * CD

FMA_EV.APPEND @IDENTITY YS  = LAM  * (JJP  * POP  - JG  * HG  - JM  * HM  - JS  * HS)

FMA_EV.APPEND @IDENTITY YNL  = RNT  + INTZ  + INTF  + INTG  - INTGR  + INTS  + DF  + DB  + DR  + DG  + DS  + TRFH  + TRGH  + TRSH  + UB

FMA_EV.APPEND @IDENTITY HFF  = HF  - HFS

FMA_EV.APPEND @IDENTITY TF1  = TFG  + TFS  + TFR

FMA_EV.APPEND @IDENTITY TCG  = TFG  + TBG

FMA_EV.APPEND @IDENTITY SIG  = SIHG  + SIFG  + SIGG

FMA_EV.APPEND @IDENTITY PUG  = PG  * COG  + WG  * JG  * HG  + WM  * JM  * HM

FMA_EV.APPEND @IDENTITY RECG  = THG  + TCG  + IBTG  + SIG  + TRFG  - DG

FMA_EV.APPEND @IDENTITY EXPG  = PUG  + TRGH  + TRGR  + TRGS  + INTG  + SUBG  - IGZ

FMA_EV.APPEND @IDENTITY SGP  = RECG  - EXPG

FMA_EV.APPEND @IDENTITY TCS  = TFS  + TBS

FMA_EV.APPEND @IDENTITY SIS  = SIHS  + SIFS  + SISS

FMA_EV.APPEND @IDENTITY PUS  = PS  * COSS  + WS  * JS  * HS

FMA_EV.APPEND @IDENTITY PFA  = THETA1  * GDPD

FMA_EV.APPEND @IDENTITY RECS  = THS  + TCS  + IBTS  + SIS  + TRGS  + TRFS  - DS

FMA_EV.APPEND @IDENTITY EXPS  = PUS  + TRSH  + UB  + INTS  + SUBS  - ISZ

FMA_EV.APPEND @IDENTITY SSP  = RECS  - EXPS

FMA_EV.APPEND @IDENTITY YD  = WF  * JF  * (HN  + 1.5  * HO)  + WG  * JG  * HG  + WM  * JM  * HM  + WS  * JS  * HS  + RNT  + INTZ  + INTF  + INTG  - INTGR  + INTS  + DF  + DB  + DR  + DG  + DS  + TRFH  + TRGH  + TRSH  + UB  - SIHG  - SIHS  + USAFF  - THG  - THS  - TRHR  - SIGG  - SISS

FMA_EV.APPEND @IDENTITY SRZ  = (YD  - PCS  * CS  - PCN  * CN  - PCD  * CD)  / YD

FMA_EV.APPEND @IDENTITY IVF  = V  - V(-1)

FMA_EV.APPEND @IDENTITY PROD  = Y  / (JF  * HF)

FMA_EV.APPEND @IDENTITY WR  = WF  / PF

FMA_EV.APPEND @IDENTITY POP  = POP1  + POP2  + POP3

FMA_EV.APPEND @IDENTITY SHRPIE  = ((1  - D2G  - D2S)  * PIEF)  / (WF  * JF  * (HN  + 1.5  * HO))

FMA_EV.APPEND @IDENTITY PCGDPR  = 100  * ((GDPR  / GDPR(-1))^4  - 1)

FMA_EV.APPEND @IDENTITY PCGDPD  = 100  * ((GDPD  / GDPD(-1))^4  - 1)

FMA_EV.APPEND @IDENTITY UBR  = BR  - BO

FMA_EV.APPEND @IDENTITY WA  = 100  * ((1  - D1GM  - D1SM  - D4G)  * WF  * JF  * (HN  + 1.5  * HO)  + (1  - D1GM  - D1SM)  * (WG  * JG  * HG  + WM  * JM  * HM  + WS  * JS  * HS  - SIGG  - SISS))  / (JF  * (HN  + 1.5  * HO)  + JG  * HG  + JM  * HM  + JS  * HS)

FMA_EV.APPEND @IDENTITY GNP  = GDP  + USROW

FMA_EV.APPEND @IDENTITY GNPR  = GDPR  + USROW  / GDPD

FMA_EV.APPEND @IDENTITY GNPD  = GNP  / GNPR

FMA_EV.APPEND @IDENTITY PIEFRET  = THETA4  * PIEF

FMA_EV.APPEND @IDENTITY AA  = AA1  + AA2

FMA_EV.APPEND @IDENTITY CCG  = CCGQ  * GDPD

FMA_EV.APPEND @IDENTITY CCH  = CCHQ  * GDPD

FMA_EV.APPEND @IDENTITY CCS  = CCSQ  * GDPD

FMA_EV.APPEND @IDENTITY DB  = DBQ  * GDPD

FMA_EV.APPEND @IDENTITY DR  = DRQ  * GDPD

FMA_EV.APPEND @IDENTITY GSB  = GSBQ  * GDPD

FMA_EV.APPEND @IDENTITY GSNN  = GSNNQ  * GDPD

FMA_EV.APPEND @IDENTITY IGZ  = IGZQ  * GDPD

FMA_EV.APPEND @IDENTITY INTZ  = INTZQ  * GDPD

FMA_EV.APPEND @IDENTITY ISZ  = ISZQ  * GDPD

FMA_EV.APPEND @IDENTITY MG  = MGQ  * GDPD

FMA_EV.APPEND @IDENTITY MH  = MHQ  * GDPD

FMA_EV.APPEND @IDENTITY MR  = MRQ  * GDPD

FMA_EV.APPEND @IDENTITY MS  = MSQ  * GDPD

FMA_EV.APPEND @IDENTITY Q  = QQ  * GDPD

FMA_EV.APPEND @IDENTITY RNT  = RNTQ  * GDPD

FMA_EV.APPEND @IDENTITY TBG  = TBGQ  * GDPD

FMA_EV.APPEND @IDENTITY TRGH  = TRGHQ  * GDPD

FMA_EV.APPEND @IDENTITY TRGS  = TRGSQ  * GDPD

FMA_EV.APPEND @IDENTITY TRSH  = TRSHQ  * GDPD

fma_ev.update
'
'  MAKE LABLES FOR ALL VARIABLES
'
AA.LABEL(d)  		Total net wealth, h, B2009$.
AA1.LABEL(d)  	Total net financial wealth, h, B2009$.
AA2.LABEL(d)  	Total net housing wealth, h, B2009$.
AB.LABEL(d)  		Net financial assets, b, B$. 
AF.LABEL(d)  		Net financial assets, f, B$.
AG.LABEL(d)  		Net financial assets, g, B$. 
AG1.LABEL(d)  	Percent of 16+ population 26-55 minus percent 16-25.
AG2.LABEL(d)  	Percent of 16+ population 56-65 minus percent 16-25. 
AG3.LABEL(d)  	Percent of 16+ population 66+ minus percent 16-25.
AH.LABEL(d)  		Net financial assets, h, B$. 
ARR.LABEL(d)  	Net financial assets, r, B$. 
AS.LABEL(d)  		Net financial assets, s, B$. 
BO.LABEL(d)  		Bank borrowing from the Fed, B$. 
BR.LABEL(d)  		Total bank reserves, B$. 
CCF1.LABEL(d)  	Capital consumption, F1, B$. 
CCG.LABEL(d)  	Capital consumption, g, B$. 
CCGQ.LABEL(d)  	Capital consumption, g, B2009$. 
CCH.LABEL(d)  	Capital consumption, h, B$. 
CCHQ.LABEL(d)  	Capital consumption, h, B2009$. 151
CCS.LABEL(d)  	Capital consumption, s, B$. 
CCSQ.LABEL(d)  	Capital consumption, s, B2009$. 152
CD.LABEL(d)  		Consumer expenditures for durable goods, B2009$. 
CDA.LABEL(d)  	Peak to peak interpolation of CD/POP. 
CDH.LABEL(d)  	Capital expenditures, consumer durable goods, h, B$. 65, 
CG.LABEL(d)  		Capital gains(+) or losses(-) on the financial assets of h, B$. 
CN.LABEL(d)  		Consumer expenditures for nondurable goods, B2009$. 
COG.LABEL(d)  	Purchases of consumption and investment goods, g, B2009$. 
COSS.LABEL(d)  	Purchases of consumption and investment goods, s, B2009$. 
CS.LABEL(d)  		Consumer expenditures for services, B2009$. 
CTB.LABEL(d)  	Net capital transfers paid, financial corporations, B$. 
CTF1.LABEL(d)  	Net capital transfers paid, nonfinancial corporations, B$. 
CTGB.LABEL(d)  	Financial stabilization payments, B$. 
CTGMB.LABEL(d)  Net capital transfers paid, g, less financial stabilization payments,B$.
CTH.LABEL(d)  	Net capital transfers paid, h, B$. 65
CTNN.LABEL(d)  	Net capital transfers paid, noncorporate business, B$. 
CTR.LABEL(d)  	Net capital transfers paid, r, B$. 
CTS.LABEL(d)  	Net capital transfers paid, s, B$. 
CUR.LABEL(d)  	Currency held outside banks, B$. 
D1G.LABEL(d)  	Personal income tax parameter, g. 
D1GM.LABEL(d)  	Marginal personal income tax rate, g. 
D1S.LABEL(d)  	Personal income tax parameter, s. 
D1SM.LABEL(d)  	Marginal personal income tax rate, s. 
D2G.LABEL(d)  	Profit tax rate, g. 
D2S.LABEL(d)  	Profit tax rate, s. 
D3G.LABEL(d)  	Indirect business tax rate, g. 
D3S.LABEL(d)  	Indirect business tax rate, s. 
D4G.LABEL(d)  	Employee social security tax rate, g. 
D5G.LABEL(d)  	Employer social security tax rate, g. 
D6G.LABEL(d)  	Capital consumption rate for CCF1, g. 
D593.LABEL(d)  	1 in 1959:3; 0 otherwise. 
D594.LABEL(d)  	1 in 1959:4; 0 otherwise. 
D601.LABEL(d)  	1 in 1960:1; 0 otherwise. 
D691.LABEL(d)  	1 in 1969:1; 0 otherwise. 
D692.LABEL(d)  	1 in 1969:2; 0 otherwise. 
D714.LABEL(d)  	1 in 1971:4; 0 otherwise. 
D721.LABEL(d)  	1 in 1972:1; 0 otherwise. 
D794823.LABEL(d)  1 in 1979:4-1982:3; 0 otherwise. 
DB.LABEL(d)  Net dividends paid, b, B$. 
DBQ.LABEL(d)  Net dividends paid, b, B2009$. 
DELD.LABEL(d)  Physical depreciation rate of the stock of durable goods, rate per quarter.
DELH.LABEL(d)  Physical depreciation rate of the stock of housing, rate per quarter. 
DELK.LABEL(d)  Physical depreciation rate of the stock of capital, rate per quarter. 
DF.LABEL(d)  Net dividends paid, f, B$. 
DG.LABEL(d)  Net dividends paid, g, B$. 
DISB.LABEL(d)  Discrepancy for b, B$. 
DISF.LABEL(d)  Discrepancy for f, B$. 
DISG.LABEL(d)  Discrepancy for g, B$. 
DISH.LABEL(d)  Discrepancy for h, B$. 
DISR.LABEL(d)  Discrepancy for r, B$. 
DISS.LABEL(d)  Discrepancy for s, B$. 
DR.LABEL(d)  Net dividends paid, r, B$. 
DRQ.LABEL(d)  Net dividends paid, r, B2009$. 
DS.LABEL(d)  Net dividends paid, s, B$. 
E.LABEL(d)  Total employment, civilian and military, millions. 
EX.LABEL(d)  Exports, B2009$. 
EXPG.LABEL(d)  Net expenditures, g, B$. 
EXPS.LABEL(d)  Net expenditures, s, B$. 
FA.LABEL(d)  Farm gross product, B2009$. 
GDP.LABEL(d)  Gross Domestic Product, B$. 
GDPD.LABEL(d)  GDP price deflator. 
GDPR.LABEL(d)  Gross Domestic Product, B2009$. 
GNP.LABEL(d)  Gross National Product, B$. 
GNPD.LABEL(d)  GNP price deflator. 
GNPR.LABEL(d)  Gross National Product, B2009$. 
GSB.LABEL(d)  Gross saving, B, B$. 
GSBQ.LABEL(d)  Gross saving, B, B2009$. 
GSCA.LABEL(d)  Gross saving, CA, B$. 
GSMA.LABEL(d)  Gross saving, MA, B$. 
GSNN.LABEL(d)  Gross saving, NN, B$. 
GSNNQ.LABEL(d)  Gross saving, NN, B2009$. 
HF.LABEL(d)  Average number of hours paid per job, f, hours per quarter. 
HFF.LABEL(d)  Deviation of HF from its peak to peak interpolation. 
HFS.LABEL(d)  Peak to peak interpolation of HF. 
HG.LABEL(d)  Average number of hours paid per civilian job, g, hours per quarter. 
HM.LABEL(d)  Average number of hours paid per military job, g, hours per quarter. 
HN.LABEL(d)  Average number of non overtime hours paid per job, f, hours per quarter. 
HO.LABEL(d)  Average number of overtime hours paid per job, f, hours per quarter. 
HS.LABEL(d)  Average number of hours paid per job, s, hours per quarter. 
IBTG.LABEL(d)  Indirect business taxes, g, B$. 
IBTS.LABEL(d)  Indirect business taxes, s, B$. 
IGZ.LABEL(d)  Gross investment, g, B$. 
IGZQ.LABEL(d)  Gross investment, g, B2009$. 
IHB.LABEL(d)  Residential investment, b, B2009$. 
IHF.LABEL(d)  Residential investment, f, B2009$. 
IHH.LABEL(d)  Residential investment, h, B2009$. 
IHHA.LABEL(d)  Peak to peak interpolation of IHH/POP. 
IKB.LABEL(d)  Nonresidential fixed investment, b, B2009$. 
IKF.LABEL(d)  Nonresidential fixed investment, f, B2009$. 
IKG.LABEL(d)  Nonresidential fixed investment, g, B2009$. 
IKH.LABEL(d)  Nonresidential fixed investment, h, B2009$. 
IM.LABEL(d)  Imports, B2009$. 
INS.LABEL(d)  Insurance and pension reserves to h from g, B$. 65, 76
INTF.LABEL(d)  Net interest payments, f, B$. 
INTG.LABEL(d)  Net interest payments, g, B$. 
INTGR.LABEL(d)  Net interest payments, g to r, B$. 
INTS.LABEL(d)  Net interest payments, s, B$. 
INTZ.LABEL(d)  Net interest payments, other, B$. 
INTZQ.LABEL(d)  Net interest payments, other, B2009$. 
ISZ.LABEL(d)  Gross investment, s, B$. 
ISZQ.LABEL(d)  Gross investment, s, B2009$. 
IVA.LABEL(d)  Inventory valuation adjustment, B$. 
IVF.LABEL(d)  Inventory investment, f, B2009$. 
JF.LABEL(d)  Number of jobs, f, millions. 
JG.LABEL(d)  Number of civilian jobs, g, millions. 
JHMIN.LABEL(d)  Number of worker hours required to produce Y, millions. 
JJ.LABEL(d)  Ratio of the total number of worker hours paid for to the total population 16 and over.
JJP.LABEL(d)  Potential value of JJ. 
JM.LABEL(d)  Number of military jobs, g, millions. 
JS.LABEL(d)  Number of jobs, s, millions. 
KD.LABEL(d)  Stock of durable goods, B2009$. 
KH.LABEL(d)  Stock of housing, h, B2009$. 
KK.LABEL(d)  Stock of capital, f, B2009$. 
KKMIN.LABEL(d)  Amount of capital required to produce Y, B2009$. 
L1.LABEL(d)  Labor force of men 25-54, millions. 
L2.LABEL(d)  Labor force of women 25-54, millions. 
L3.LABEL(d)  Labor force of all others, 16+, millions. 
LAM.LABEL(d)  Amount of output capable of being produced per worker hour. 
LM.LABEL(d)  Number ofmoonlighters": difference between the total number of jobs (establishment data) and the total number of people employed (household survey data), millions. 
M1.LABEL(d)  Money supply, end of quarter, B$. 
MB.LABEL(d)  Net demand deposits and currency, b, B$. 
MDIF.LABEL(d)  Net increase in demand deposits and currency of banks in U.S.possessions plus change in demand deposits and currency of private nonbank financial institutions plus change in demand deposits and currency of federally sponsored credit agencies and mortgage pools minus mail float, U.S. government, B$. 
MF.LABEL(d)  Demand deposits and currency, f, B$. 
MG.LABEL(d)  Demand deposits and currency, g, B$. 
MGQ.LABEL(d)  Demand deposits and currency, g, B2009$. 
MH.LABEL(d)  Demand deposits and currency, h, B$. 66, 
MHQ.LABEL(d)  Demand deposits and currency, h, B2009$. 
MR.LABEL(d)  Demand deposits and currency, r, B$. 
MRQ.LABEL(d)  Demand deposits and currency, r, B2009$. 
MS.LABEL(d)  Demand deposits and currency, s, B$. 
MSQ.LABEL(d)  Demand deposits and currency, s, B2009$. 
MUH.LABEL(d)  Amount of output capable of being produced per unit of capital. 
NICD.LABEL(d)  Net investment in consumer durables, h, B$. 
NNF.LABEL(d)  Net acquisition of nonproduced nonfinancial assets, f, B$. 
NNG.LABEL(d)  Net acquisition of nonproduced nonfinancial assets, g, B$. 
NNH.LABEL(d)  Net acquisition of nonproduced nonfinancial assets, h, B$. 
NNR.LABEL(d)  Net acquisition of nonproduced nonfinancial assets, r, B$. 
NNS.LABEL(d)  Net acquisition of nonproduced nonfinancial assets, s, B$. 
PCD.LABEL(d)  Price deflator for CD. 
PCGDPD.LABEL(d)  Percentage change in GDPD, annual rate, percentage points. 
PCGDPR.LABEL(d)  Percentage change in GDPR, annual rate, percentage points. 
PCM1.LABEL(d)  Percentage change in M1, annual rate, percentage points. 
PCN.LABEL(d)  Price deflator for CN. 
PCS.LABEL(d)  Price deflator for CS. 
PD.LABEL(d)  Price deflator for X - EX + IM (domestic sales). 
PEX.LABEL(d)  Price deflator for EX. 
PF.LABEL(d)  Price deflator for non farm sales. 
PFA.LABEL(d)  Price deflator for farm sales. 
PG.LABEL(d)  Price deflator for COG. 
PH.LABEL(d)  Price deflator for CS + CN + CD + IHH inclusive of indirect business taxes.
PIEF.LABEL(d)  Before tax profits, f, B$. 
PIEFRET.LABEL(d)  Foreign earnings retained abroad, f, B$. 
PIH.LABEL(d)  Price deflator for residential investment. 
PIK.LABEL(d)  Price deflator for nonresidential fixed investment. 
PIM.LABEL(d)  Price deflator for IM. 
PIV.LABEL(d)  Price deflator for inventory investment, adjusted. 
PKH.LABEL(d)  Market price of KH. 
POP.LABEL(d)  Noninstitutional population 16+, millions. 
POP1.LABEL(d)  Noninstitutional population of men 25-54, millions. 
POP2.LABEL(d)  Noninstitutional population of women 25-54, millions. 
POP3.LABEL(d)  Noninstitutional population of all others, 16+, millions. 
PROD.LABEL(d)  Output per paid for worker hour ("productivity"). 
PS.LABEL(d)  Price deflator for COS. 
PSI1.LABEL(d)  Ratio of PEX to PX. 
PSI2.LABEL(d)  Ratio of PCS to (1 + D3G + D3S)PD. 
PSI3.LABEL(d)  Ratio of PCN to (1 + D3G + D3S)PD. 
PSI4.LABEL(d)  Ratio of PCD to (1 + D3G + D3S)PD. 
PSI5.LABEL(d)  Ratio of PIH to PD. 
PSI6.LABEL(d)  Ratio of PIK to PD. 
PSI7.LABEL(d)  Ratio of PG to PD. 
PSI8.LABEL(d)  Ratio of PS to PD. 
PSI9.LABEL(d)  Ratio of PIV to PD. 
PSI10.LABEL(d)  Ratio of WG to WF. 
PSI11.LABEL(d)  Ratio of WM to WF. 
PSI12.LABEL(d)  Ratio of WS to WF. 
PSI13.LABEL(d)  Ratio of gross product of g and s to total employee hours of g and s.
PSI14.LABEL(d)  Ratio of PKH to PD. 
PSI15.LABEL(d)  Ratio of INTGR to INTG. 
PUG.LABEL(d)  Purchases of goods and services, g, B$. 
PUS.LABEL(d)  Purchases of goods and services, s, B$. 
PX.LABEL(d)  Price deflator for total sales. 
Q.LABEL(d)  Gold and foreign exchange, g, B$. 
QQ.LABEL(d)  Gold and foreign exchange, g6, B2009$. 
RB.LABEL(d)  Bond rate, percentage points.
RECG.LABEL(d)  Net receipts, g, B$. 
RECS.LABEL(d)  Net receipts, s, B$. 
RM.LABEL(d)  Mortgage rate, percentage points. 
RMA.LABEL(d)  After tax mortgage rate, percentage points. 
RNT.LABEL(d)  Rental income, h, B$. 
RNTQ.LABEL(d)  Rental income, h, B2009$. 
RS.LABEL(d)  Three-month Treasury bill rate, percentage points. 
RSA.LABEL(d)  After tax bill rate, percentage points. 
SB.LABEL(d)  Financial saving, b, B$. 
SF.LABEL(d)  Financial saving, f, B$. 
SG.LABEL(d)  Financial saving, g, B$. 
SGP.LABEL(d)  NIPA surplus (+) or deficit (-), g, B$. 
SH.LABEL(d)  Saving, h, B$. 66
SHRPIE.LABEL(d)  Ratio of after tax profits to the wage bill net of employer social security taxes.
SIFG.LABEL(d)  Employer social insurance contributions, f to g, B$. 
SIFS.LABEL(d)  Employer social insurance contributions, f to s, B$. 
SIG.LABEL(d)  Total employer and employee social insurance contributions to g, B$. 
SIGG.LABEL(d)  Employer social insurance contributions, g to g, B$. 
SIHG.LABEL(d)  Employee social insurance contributions, h to g, B$. 
SIHS.LABEL(d)  Employee social insurance contributions, h to s, B$. 
SIS.LABEL(d)  Total employer and employee social insurance contributions to s, B$.
SISS.LABEL(d)  Employer social insurance contributions, s to s, B$. 
SR.LABEL(d)  Financial saving, r, B$. 
SRZ.LABEL(d)  Approximate NIPA saving rate, h. 
SS.LABEL(d)  Financial saving, s, B$. 
SSP.LABEL(d)  NIPA surplus (+) or deficit (-), s, B$. 
STAT.LABEL(d)  Statistical discrepancy, B$. 
STATP.LABEL(d)  Statistical discrepancy relating to the use of chain type price indices, B2009$. 
SUBG.LABEL(d)  Subsidies less current surplus of government enterprises, g, B$. 
SUBS.LABEL(d)  Subsidies less current surplus of government enterprises, s, B$. 
T.LABEL(d)  1 in 1952:1, 2 in 1952:2, etc. 
TAUG.LABEL(d)  Progressivity tax parameter in personal income tax equation for g. 
TAUS.LABEL(d)  Progressivity tax parameter in personal income tax equation for s. 
TFR.LABEL(d)  Taxes, f to r, B$. 
TBG.LABEL(d)  Corporate profit taxes, b to g, B$. 
TBGQ.LABEL(d)  Corporate profit taxes, b to g, B2009$. 
TBS.LABEL(d)  Corporate profit taxes, b to s, B$. 
TCG.LABEL(d)  Corporate profit tax receipts, g, B$. 
TCS.LABEL(d)  Corporate profit tax receipts, s, B$. 
TF1.LABEL(d)  Corporate profit tax payments, F1, B$. 
TFG.LABEL(d)  Corporate profit taxes, f to g, B$. 
TFS.LABEL(d)  Corporate profit taxes, f to s, B$. 
THETA1.LABEL(d)  Ratio of PFA to GDPD. 
THETA2.LABEL(d)  Ratio of CDH to PCD  CD. 
THETA3.LABEL(d)  Ratio of NICD to PCD  CD. 
THETA4.LABEL(d)  Ratio of PIEFRET to PIEF. 132
THG.LABEL(d)  Personal income taxes, h to g, B$. 
THS.LABEL(d)  Personal income taxes, h to s, B$. 
TRFG.LABEL(d)  Transfer payments, f to g, B$. 
TRFH.LABEL(d)  Transfer payments, f to h, B$. 
TRFR.LABEL(d)  Transfer payments, f to r, B$. 
TRFS.LABEL(d)  Transfer payments, f to s, B$. 
TRGH.LABEL(d)  Transfer payments (net), g to h, B$. 
TRGHQ.LABEL(d)  Transfer payments (net), g to h, B2009$. 
TRGR.LABEL(d)  Transfer payments (net), g to r, B$. 
TRGS.LABEL(d)  Transfer payments, g to s, B$. 
TRGSQ.LABEL(d)  Transfer payments, g to s, B2009$. 
TRHR.LABEL(d)  Transfer payments, h to r, B$. 
TRRS.LABEL(d)  Transfer payments, r to s, B$. 
TRSH.LABEL(d)  Transfer payments, s to h, excluding unemployment insurance benefits, B$. 
TRSHQ.LABEL(d)  Transfer payments, s to h, excluding unemployment insurance benefits, B2009$.
U.LABEL(d)  Number of people unemployed, millions. 
UB.LABEL(d)  Unemployment insurance benefits, B$. 
UBR.LABEL(d)  Unborrowed reserves, B$. 
UR.LABEL(d)  Civilian unemployment rate. 
USAFF.LABEL(d)  Contributions for government social insurance, U.S.-affiliated areas, B$.
USOTHER.LABEL(d)  Net receipts of factor income from the rest of theworld not counting net interest receipts, net dividend receipts, and foreign earnings retained abroad, B$.
USROW.LABEL(d)  Net receipts of factor income from the rest of the world, B$. 
V.LABEL(d)  Stock of inventories, f, B2009$. 
WA.LABEL(d)  After tax wage rate. (Includes supplements to wages and salaries except employer contributions for social insurance.) 
WF.LABEL(d)  Average hourly earnings excluding overtime of workers in f. (Includes supplements to wages and salaries except employer contributions for social insurance.) 
WG.LABEL(d)  Average hourly earnings of civilian workers in g. (Includes supplements to wages and salaries including employer contributions for social insurance.) 
WH.LABEL(d)  Average hourly earnings excluding overtime of all workers. (Includes supplements to wages and salaries except employer contributions for social insurance.) 
WM.LABEL(d)  Average hourly earnings of military workers. (Includes supplements to wages and salaries including employer contributions for social insurance.)
WR.LABEL(d)  Real wage rate of workers in f. (Includes supplements to wages and salaries except employer contributions for social insurance.)
WS.LABEL(d)  Average hourly earnings of workers in s. (Includes supplements to wages and salaries including employer contributions for social insurance.)
X.LABEL(d)  Total sales, B2009$. 
XX.LABEL(d)  Total sales, B$. 
Y.LABEL(d)  Total production, B2009$. 
YD.LABEL(d)  Disposable income, h, B$. 
YNL.LABEL(d)  Before tax nonlabor income, h, B$. 
YS.LABEL(d)  Potential output, B2009$. 
YT.LABEL(d)  Taxable income, h, B$.
SMPL %DEND+1 2022Q4


